#!/usr/bin/perl
# $Id: encrypt.pl,v 1.14 2011/02/05 21:09:48 rjs Exp $
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# encryption sample
#

use PDFlib::PLOP 4.1;

# parameters for the input document
my $in_filename = "PLOP-datasheet.pdf";
my $in_password = "";

# parameters for the output document
my $out_filename = "PLOP-datasheet-encrypted.pdf";
my $out_master = "DEMO";
my $out_user = "demo";
my $permissions = "";

# This is where input files live. Adjust as necessary.
my $searchpath = "../data";

my $doc;
# create a new PLOP object
my $plop = new PDFlib::PLOP;

eval {
    my $optlist;

    $optlist = sprintf("searchpath={%s}", $searchpath);
    $plop->set_option($optlist);

    # open unprotected input file without any password
    $optlist = sprintf("password {%s} ", $in_password);
    if (($doc = $plop->open_document($in_filename, $optlist)) == -1)
    {
	printf("Error: %s", $plop->get_errmsg());
	$plop->delete();
	exit;
    }

    # create the output file with a password
    $optlist = sprintf("masterpassword {%s} userpassword {%s} permissions {%s}", $out_master, $out_user, $permissions);
    if ($plop->create_file($out_filename, $optlist)== -1)
    {
	printf("Error: %s", $plop->get_errmsg());
	$plop->delete();
	exit;
    }

    # close input and output files
    $plop->close_document($doc);
};
if ($@) {
    die("$0: PLOP Exception occurred:\n$@");
}
