#!/usr/bin/perl
# $Id: encrypt.pl,v 1.1 2011/02/05 21:09:49 rjs Exp $
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# encryption sample
#

use plop_pl 4.1

# parameters for the input document
my $in_filename = "PLOP-datasheet.pdf";
my $in_password = "";

# parameters for the output document
my $out_filename = "PLOP-datasheet-encrypted.pdf";
my $out_master = "DEMO";
my $out_user = "demo";
my $permissions = "";

# This is where input files live. Adjust as necessary.
my $searchpath = "../data";

my $doc;
# create a new PLOP object
my $plop = PLOP_new();

eval {
    my $optlist;

    $optlist = sprintf("searchpath={%s}", $searchpath);
    PLOP_set_option($plop, $optlist);

    # open unprotected input file without any password
    $optlist = sprintf("password {%s} ", $in_password);
    if (($doc = PLOP_open_document($plop, $in_filename, $optlist)) == -1)
    {
	printf("Error: %s", PLOP_get_errmsg($plop));
	PLOP_delete($plop);
	exit;
    }

    # create the output file with a password
    $optlist = sprintf("masterpassword {%s} userpassword {%s} permissions {%s}", $out_master, $out_user, $permissions);
    if (PLOP_create_file($plop, $out_filename, $optlist)== -1)
    {
	printf("Error: %s", PLOP_get_errmsg($plop));
	PLOP_delete($plop);
	exit;
    }

    # close input and output files
    PLOP_close_document($plop, $doc);
};
if ($@) {
    printf("encrypt: PLOP exception occurred:\n");
    printf("$@\n");
    PLOP_delete($plop);
    exit;
}

# delete the PLOP object
PLOP_delete($plop);
