# $Id: plop_pl.pm,v 1.11 2011/02/21 13:02:31 rjs Exp $
#---------------------------------------------------------------------------#
#          Copyright (c) 2002-2010 PDFlib GmbH. All rights reserved.        #
#---------------------------------------------------------------------------#
#    This software may not be copied or distributed except as expressly     #
#    authorized by PDFlib GmbH's general license agreement or a custom      #
#    license agreement signed by PDFlib GmbH.                               #
#    For more information about licensing please refer to www.pdflib.com.   #
#---------------------------------------------------------------------------#

package plop_pl;
require Exporter;
require DynaLoader;
$VERSION=4.1;
@ISA = qw(Exporter DynaLoader);
package plopc;
bootstrap plop_pl;
var_plop_init();
@EXPORT = qw( );

# ---------- BASE METHODS -------------

package plop_pl;

sub TIEHASH {
    my ($classname,$obj) = @_;
    return bless $obj, $classname;
}

sub CLEAR { }

sub this {
    my $ptr = shift;
    return tied(%$ptr);
}


# ------- FUNCTION WRAPPERS --------

package plop_pl;

*PLOP_new = *plopc::PLOP_new;
*PLOP_delete = *plopc::PLOP_delete;
*PLOP_open_document = *plopc::PLOP_open_document;
*PLOP_open_document_mem = *plopc::PLOP_open_document_mem;
*PLOP_create_file = *plopc::PLOP_create_file;
*PLOP_get_buffer = *plopc::PLOP_get_buffer;
*PLOP_close_document = *plopc::PLOP_close_document;
*PLOP_create_pvf = *plopc::PLOP_create_pvf;
*PLOP_delete_pvf = *plopc::PLOP_delete_pvf;
*PLOP_info_pvf = *plopc::PLOP_info_pvf;
*PLOP_set_option = *plopc::PLOP_set_option;
*PLOP_pcos_get_number = *plopc::PLOP_pcos_get_number;
*PLOP_pcos_get_string = *plopc::PLOP_pcos_get_string;
*PLOP_pcos_get_stream = *plopc::PLOP_pcos_get_stream;
*PLOP_convert_to_unicode = *plopc::PLOP_convert_to_unicode;
*PLOP_get_errnum = *plopc::PLOP_get_errnum;
*PLOP_get_errmsg = *plopc::PLOP_get_errmsg;
*PLOP_get_apiname = *plopc::PLOP_get_apiname;
*PLOP_get_value = *plopc::PLOP_get_value;
*PLOP_set_value = *plopc::PLOP_set_value;
*PLOP_set_parameter = *plopc::PLOP_set_parameter;
*PLOP_open_file = *plopc::PLOP_open_file;
*PLOP_close = *plopc::PLOP_close;
*PLOP_utf16_to_utf8 = *plopc::PLOP_utf16_to_utf8;
*PLOP_utf8_to_utf16 = *plopc::PLOP_utf8_to_utf16;

@EXPORT = qw(
PLOP_new
PLOP_delete
PLOP_open_document
PLOP_open_document_mem
PLOP_create_file
PLOP_get_buffer
PLOP_close_document
PLOP_create_pvf
PLOP_delete_pvf
PLOP_info_pvf
PLOP_set_option
PLOP_pcos_get_number
PLOP_pcos_get_string
PLOP_pcos_get_stream
PLOP_convert_to_unicode
PLOP_get_errnum
PLOP_get_errmsg
PLOP_get_apiname
PLOP_get_value
PLOP_set_value
PLOP_set_parameter
PLOP_open_file
PLOP_close
PLOP_utf16_to_utf8
PLOP_utf8_to_utf16
);

# ------- VARIABLE STUBS --------

package plop_pl;

1;
