# PDFlib PLOP: PDF Linearization, Optimization, Protection
# linearization sample
#
# $Id: linearize.py,v 1.2 2011/02/23 15:11:40 rjs Exp $
#

from sys import *
from traceback import *
from plop_py import *


in_filename  = "PLOP-datasheet.pdf"
out_filename = "PLOP-datasheet-linearized.pdf"

# This is where input files live. Adjust as necessary.
searchpath = "../data"

# create a new PLOP object
plop = PLOP_new()

try:
    try:
        optlist = "searchpath={%s}" % searchpath
        PLOP_set_option(plop, optlist)

        # open input file
        doc = PLOP_open_document(plop, in_filename, "")
        if (doc == -1):
            raise PLOPException("Error: %s" % PLOP_get_errmsg(plop))

        # create the linearized output file
        if (PLOP_create_file(plop, out_filename, \
                    "linearize docinfo={Author {PDFlib GmbH}}") == -1):
            raise PLOPException("Error: %s" % PLOP_get_errmsg(plop))

        # close input and output files
        PLOP_close_document(plop, doc)
    except PLOPException:
        print_exc(file=stdout)

except Exception:
    print_exc(file=stdout)

finally:
    PLOP_delete(plop)
