# PDFlib PLOP: PDF Linearization, Optimization, Protection
# sample for setting permissions
#
# $Id: noprint.py,v 1.2 2011/02/23 15:11:40 rjs Exp $

from sys import *
from traceback import *
from plop_py import *

# parameters for the input document
in_filename = "PLOP-datasheet.pdf"
in_password = ""

# parameters for the output document
out_filename = "PLOP-datasheet-noprint.pdf"
out_master = "DEMO"
out_user = ""

# You can add more permission strings here
permissions = "noprint nocopy"

# This is where input files live. Adjust as necessary.
searchpath = "../data"

# create a new PLOP object
plop = PLOP_new()

try:
    try:
        optlist = "searchpath={%s}" % searchpath
        PLOP_set_option(plop, optlist)

        # open unprotected input document without any password
        optlist = "password {%s} " % in_password
        doc = PLOP_open_document(plop, in_filename, optlist)
        if (doc == -1):
            raise PLOPException("Error: %s" % PLOP_get_errmsg(plop))

        # create the output file and apply permission settings
        optlist = "masterpassword {%s} userpassword {%s} permissions {%s}" % \
            (out_master, out_user, permissions)
        if (PLOP_create_file(plop, out_filename, optlist) == -1):
            raise PLOPException("Error: %s" % PLOP_get_errmsg(plop))

        # close input and output files
        PLOP_close_document(plop, doc)

    except PLOPException:
        print_exc(file=stdout)

except Exception:
    print_exc(file=stdout)

finally:
    PLOP_delete(plop)
